#include "MMMotor.h"
#pragma once
/*
Die Klasse Fahrwerk steuert direkt die beiden Motoren fuer die Raeder an und 
 kann so den Roboter mit einer gewuenschten Geschw. geradeaus fahren lassen oder ihn um
 die eigene Achse drehen lassen.
 */
class Fahrwerk {
private:
  MMMotor motorLeft;  // Das Fahrwerk besteht aus zwei Motoren (ebenfalls Objekte)
  MMMotor motorRight;

public:
  void setup(int forwLeft, int revLeft, int throtLeft, int hallALeft, int hallBLeft, 
  int forwRight, int revRight, int throtRight, int hallARight, int hallBRight) {
    motorLeft.setup(forwLeft, revLeft, throtLeft, hallALeft, hallBLeft);
    motorRight.setup(forwRight, revRight, throtRight, hallARight, hallBRight);
  }


  /*
drive erwartet die zu fahrende Geschwindigkeit und einen Faktor. Bei positiver Geschw.
   faehrt der Roboter geradeaus, bei negativer rueckwaerts. Der Faktor ist standardmäßig 1 und
   wird momentan nicht benoetigt, sondern wahr eine Idee um spaeter auch Kurven fahren 
   zu koennen.
   */
  void drive(float newSpeed, float fak) {
    motorLeft.setTSpeed(newSpeed);
    motorRight.setTSpeed(newSpeed*fak);
  }

  // turn dreht bei positiven Geschwindigkeiten gegen und bei negativen G. im Uhrzeigersinn.
  void turn(float newSpeed){
    motorLeft.setTSpeed(-newSpeed);
    motorRight.setTSpeed(newSpeed);
  }

  /*
regulate ruft fuer jeden Motor den PI-Regler auf und sorgt so dafuer, dass die vorgegebene 
   Geschwindigkeit erreicht und gehalten wird.
   Außerdem Leitet er die Information weiter, ob beide Raeder gedreht haben.
   */
  boolean regulate(){
    boolean a = motorLeft.regulate();
    boolean b = motorRight.regulate();
    if(a || b){return true;}
    return false;
  }
};








