#include "Arduino.h"
#pragma once

/* 
 Pumpe kann zu giessende Wassermengen in Bewaesserungszeiten 
 uumrechnen, diese speichern, den Giessvorgang starten und beenden
 sowie die aktuelle Giessdauer ausgeben.
 */

class Pumpe {
private:
  int pumpPin;
  unsigned long giessdauer;

public:
  void setup(int newPump){
    pumpPin = newPump;
    digitalWrite(pumpPin, LOW);
    pinMode(pumpPin, OUTPUT);
  }

  void startGiessen(){
    digitalWrite(pumpPin, HIGH);
  }

  void stopGiessen(){
    digitalWrite(pumpPin, LOW);
  }

  void neueGiessdauer(unsigned long wassermenge){
    giessdauer = wassermenge*3800;
  }

  unsigned long getGiessdauer() {
    return giessdauer;
  }
};



