#include "Arduino.h"  // ohne das laufen arduinospezifische
#pragma once

// Schalter ist ein Druckknopf, der mitteilt, ob er betaetigt wurde.
class Schalter {
private:
  int schalterPin;
  unsigned long lastPress; //Zeitpunkt des letzten Drueckers

public:
    void setup(int newPin) {
    schalterPin = newPin;
    pinMode(schalterPin, INPUT);
  }

  /* pressButton gibt zurueck, ob der Knopf gedrueckt wurde.
   Um bei schnellen Anfragen hintereinander kein Durcheinander zu stiften,
   muss zwischen zwei Betaetigungen eine Sekunde vergangen sein, damit 
   der Druck als weitere Betaetigung gewertet wird.
   */
  boolean pressButton() {
    if(((millis() - lastPress) > 1000) && (digitalRead(schalterPin)==HIGH)){
      lastPress = millis();
      return true;
    }
    return false;
  }
};



